<?php

namespace App\Http\Controllers;

use App\Http\Requests;
use Illuminate\Http\Request;
use Auth;
use App\Models\Customer;
use App\Models\User;
use App\Models\WhatsappSmsHistory;
use App\Models\WhatsappCampaignHistory;

class HomeController extends Controller
{
    /**
     * Create a new controller instance.
     *
     * @return void
     */

    public $user;

    public function __construct()
    {
        // $this->middleware('auth');

        $this->user = \Illuminate\Support\Facades\Auth::user();
    }

    /**
     * Show the application dashboard.
     *
     * @return \Illuminate\Http\Response
     */
    public function index()
    {
        if(Auth::guest()){
            return redirect('/login');
        }else{
            if(!empty($this->user) && $this->user->user_type == 'administrator'){
                $admins = User::all()->count();
            }else{
                $admins = User::where('user_type', '!=', 'administrator')->get()->count();
            }
            $customers = Customer::where('status', 0)->where('opt_out_db', 'no')->count();
            $sms = WhatsappSmsHistory::count();
            $campaigns = WhatsappCampaignHistory::count();
            
            $data["customers"] = $customers;
            $data['admins'] = $admins;
            $data['sms'] = $sms;
            $data['campaigns'] = $campaigns;

            return view('layouts.dashboardcontent',$data);
        }
        
    }
}
