<?php

namespace App\Http\Controllers;

use App\Http\Requests;
use App\Events\WhatsApp;
use Illuminate\Http\Request;
use App\Model\WhatsappClientDevice;
use App\Model\WhatsappCampaign;
use App\Model\WhatsappCampaignContacts;
use App\Model\WhatsappCampaignHistory;
use App\Model\IntCountryCodes;
use App\Model\Customer;
use App\Model\CustomerGroup;
use App\Model\CustomerGroupCustomer;
use App\Model\WhatsappSmsHistory;
use Illuminate\Support\Facades\DB;
use Illuminate\Support\Facades\Input;
use Illuminate\Support\Facades\Auth;
use Illuminate\Support\Facades\Session;
use stdClass;

class WebhookController extends Controller
{
    /**
     * Create a new controller instance.
     *
     * @return void
     */
    public function __construct()
    {
       
        $this->whatsApp = new WhatsApp();
    }

    /**
     * Show the application dashboard.
     *
     * @return \Illuminate\Http\Response
     */


    public function webhookUpdateMessageStatus(Request $request){
        $data = $request->all();
        
        if(gettype($data)=='array'){
            foreach ($data as $key => $value) {
                
                $messageId = $value['data']['id'];
    
                $smsHistory = WhatsappSmsHistory::where('message_id',$messageId)->first();
    
                if($smsHistory!=''){
                    $smsHistory->status=$value['data']['status'];
                    $smsHistory->deliveryStatus=$value['data']['deliveryStatus'];
                    if($value['data']['deliveryStatus']=="failed"){
                        $smsHistory->failed_reason=$value['data']['failureReason'];
                    }

                    $smsHistory->save();
                }   
            }
        }else{
            $messageId = $data['id'];
    
            $smsHistory = WhatsappSmsHistory::where('message_id',$messageId)->first();
    
            if($smsHistory!=''){
                $smsHistory->deliveryStatus=$data['ack'];
                $smsHistory->save();
            }           
        }
        
        
          return response()->json(['status' => 200, 'body' => $data],200);
        // if($id=='whatsapp-gulshan-club-wsit-wsit97480'){

            

        // }
    }


    public function manageUnsentMessage(){
        $clientDeviceInfo = WhatsappClientDevice::where('status', 'completed')->first();

        $pendingMessages = WhatsappSmsHistory::where('cron_processing_status',false)->limit(25)->get();

        foreach ($pendingMessages as $key => $value) {
            $data = new stdClass();
            $data->message = $value->message;
            // $data->phone = $value->phone;
            $data->broadcast = $value->broadcast_id;
            
            
            
            if($value->type=='scheduled'){
                $datetime = $value->time;
                $datetimes = explode(" ", $datetime);
                $scheduleTime = $datetimes[0].'T'.$datetimes[1].'Z';
                $schedule = new stdClass();
                $schedule->date = $scheduleTime;
                
                /**Added to message */
                $data->schedule = $schedule;
            }

            if($value->media_url!=null && $value->media_url!=''){
                $mediaUrl = $value->media_url;
                $mediaFile = new stdClass();
                $mediaFile->file = $mediaUrl;
                $mediaFileJson = json_encode($mediaFile);

                /**Added to message */
                $data->media = json_decode($mediaFileJson);
            }


            $myJSON = json_encode($data);

            $result = $this->whatsApp->post($myJSON);
            $result = json_decode($result);

            if($result->success){
                $result = json_decode($result->data);
                if($result->status==400){
                    $smsHistory = WhatsappSmsHistory::where('id',$value->id)->first();
                    // $smsHistory->message_id = $result->id;
                    $smsHistory->status = "failed";
                    $smsHistory->deliveryStatus = "failed";
                    $smsHistory->failed_reason = $result->message;
                    $smsHistory->cron_processing_status = 1;
                    $smsHistory->save();
                }else{
                    $smsHistory = WhatsappSmsHistory::where('id',$value->id)->first();
                    $smsHistory->message_id = $result->id;
                    $smsHistory->cron_processing_status = 1;
                    $smsHistory->save();
                }
            }
        }
        
    }

}