<?php

namespace App\Models;

use Illuminate\Database\Eloquent\Model;

class WhatsappSmsHistory extends Model
{
    protected $table='create_whatsapp_sms_history';

    public function campaign(){
        return $this->hasOne('App\Model\WhatsappCampaignHistory','id','campaign_id');
    }

    public function customer(){
        return $this->hasOne('App\Model\Customer','id','customer_id');
    }

    public function customerGroupCustomerBroadcast(){
        return $this->hasMany('App\Model\CustomerGroupCustomer','group_broadcast_id','group_broadcast_id');
    }


    public function group(){
        return $this->hasOne('App\Model\CustomerGroup','id','group_id');
    }

    public function broadcast(){
        return $this->hasOne('App\Model\GroupBroadcast','id','group_broadcast_id');
    }

    public function getBroadcastNameAttribute(){
        return $this->broadcast()->first()->broadcast_name ?? "";
    }
}
